
#ifndef __SC2102_H
#define __SC2102_H
                    
#include <stdarg.h>
                    
#include <utility.h>
#include <array.h>
#include <strings.h>
#include <real.h>
#include <isam.h>


///////////////////////////////////////////////////////////
// Totalizzatore
///////////////////////////////////////////////////////////

class TTotal : public TObject
{
  TImporto _importo;
  real _scaduto;
  real _esposto;
  real _importo_lire;
  
public:
  const TImporto& importo() const { return _importo; }  
  const real& importo_lire() const { return _importo_lire; }
  const real& scaduto() const { return _scaduto; }
  const real& esposto() const { return _esposto; }
  TImporto& importo() { return _importo; }  
  real& importo_lire() { return _importo_lire; }  
  real& scaduto() { return _scaduto; }
  real& esposto() { return _esposto; }
  
  TTotal(const TImporto& imp, const real& scaduto, 
         const real& esposto, const real& implire);
  virtual ~TTotal() {}
};

class TTotalizer : public TAssoc_array
{ 
public:
  void add(const TImporto& imp, const real& scaduto, 
           const real& esposto, const real& implire, const TString& val);

  TTotalizer() { }
  virtual ~TTotalizer() { }
};


///////////////////////////////////////////////////////////
// TFilearray
///////////////////////////////////////////////////////////

class TFile_array
{         
  TArray _file;

public:
  void open(int num, ...);
  void close();
  TLocalisamfile& file(int num) const { return (TLocalisamfile&)_file[num]; }
  TLocalisamfile& operator[](int num) const { return file(num); }

  TFile_array() {}
  virtual ~TFile_array() {}
};

#endif // __SC2102_H
